package com.biel.FastSurvival;

import java.util.ArrayList;

import org.bukkit.Bukkit;
import org.bukkit.Color;
import org.bukkit.Difficulty;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.World;
import org.bukkit.block.Block;
import org.bukkit.block.BlockFace;
import org.bukkit.block.PistonMoveReaction;
import org.bukkit.entity.Entity;
import org.bukkit.entity.Item;
import org.bukkit.entity.LivingEntity;
import org.bukkit.entity.Player;
import org.bukkit.entity.Skeleton;
import org.bukkit.entity.Zombie;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.block.Action;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.event.entity.CreatureSpawnEvent;
import org.bukkit.event.entity.CreatureSpawnEvent.SpawnReason;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.event.weather.LightningStrikeEvent;
import org.bukkit.event.world.WorldInitEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.bukkit.potion.PotionEffect;
import org.bukkit.potion.PotionEffectType;
import org.bukkit.util.Vector;

import com.bergerkiller.bukkit.common.controller.EntityController;
import com.bergerkiller.bukkit.common.entity.CommonEntity;
import com.bergerkiller.bukkit.common.entity.type.CommonItem;
import com.bergerkiller.bukkit.common.entity.type.CommonLivingEntity;
import com.bergerkiller.bukkit.common.entity.type.CommonPlayer;
import com.bergerkiller.bukkit.common.events.EntityAddEvent;
import com.biel.FastSurvival.Bows.BowRecipeGenerator;
import com.biel.FastSurvival.Bows.BowUtils;
import com.biel.FastSurvival.Bows.BowUtils.BowType;
import com.biel.FastSurvival.Bows.CustomBowsListener;
import com.biel.FastSurvival.Dimensions.Moon.ElectricBossPopulator;
import com.biel.FastSurvival.Dimensions.Moon.MoonUtils;
import com.biel.FastSurvival.TerrainBoss.SlimeBossPopulator;
import com.biel.FastSurvival.Turrets.Turret;

public class EventListener implements Listener {
	@EventHandler
	public void onWorldInit(WorldInitEvent evt) {	
		evt.getWorld().setAutoSave(true);
		
		if (MoonUtils.IsEarth(evt.getWorld())){
			//evt.getWorld().getPopulators().add(new SlimeBossPopulator());
			evt.getWorld().getPopulators().add(new NetherPopulator());
			evt.getWorld().getPopulators().add(new LogPopulator());
			evt.getWorld().setMonsterSpawnLimit(80);
		}

		if (MoonUtils.IsMoon(evt.getWorld())){
			evt.getWorld().getPopulators().add(new ElectricBossPopulator());
			evt.getWorld().setMonsterSpawnLimit(180);
			evt.getWorld().setGameRuleValue("doDaylightCycle", "false");
			evt.getWorld().setGameRuleValue("doFireTick", "false");
			evt.getWorld().setDifficulty(Difficulty.NORMAL);
			evt.getWorld().setTime(15000);
		}
	}
	@EventHandler
	public void onBlockBrak(BlockBreakEvent evt) {	
		
		if (evt.getPlayer() != null){
			Player p = evt.getPlayer();
			Block blk = evt.getBlock();
			ItemStack i = p.getItemInHand();
			if (blk.getType() == Material.SPONGE){
				evt.setCancelled(true);
				evt.getBlock().setType(Material.AIR);
				p.getWorld().dropItemNaturally(evt.getBlock().getLocation(), Utils.setItemNameAndLore(new ItemStack(Material.SPONGE), "Accs al cel", "Fragment per crear el Knock Up"));
			}
			if (blk.getType() == Material.GRAVEL){
				if (Utils.Possibilitat(25)){
					evt.getBlock().getDrops().clear();
				}
				if (Utils.Possibilitat(1)){
					p.getWorld().dropItemNaturally(blk.getLocation(), new ItemStack(Material.IRON_INGOT));
				}
				if (Utils.Possibilitat(4)){
					p.getWorld().dropItemNaturally(blk.getLocation(), new ItemStack(Material.IRON_FENCE));
				}
				if (Utils.Possibilitat(4)){
					p.getWorld().dropItemNaturally(blk.getLocation(), new ItemStack(Material.GOLD_NUGGET, 2));
				}
			}
			if (blk.getType() == Material.STONE){
				if (Utils.Possibilitat(1)){
					if (Utils.Possibilitat(1)){
						p.getWorld().dropItemNaturally(blk.getLocation(), new ItemStack(Material.DIAMOND));
					}
					if (Utils.Possibilitat(2)){
						p.getWorld().dropItemNaturally(blk.getLocation(), new ItemStack(Material.IRON_ORE));
					}
					if (Utils.Possibilitat(1)){
						p.getWorld().dropItemNaturally(blk.getLocation(), new ItemStack(Material.GOLD_ORE));
					}
				}
			}
			if (blk.getType() == Material.MOB_SPAWNER){
				
					p.getWorld().dropItemNaturally(blk.getLocation(), new ItemStack(Material.IRON_INGOT, 10));
					p.getWorld().dropItemNaturally(blk.getLocation(), new ItemStack(Material.IRON_FENCE, 6));
					if (Utils.Possibilitat(1)){
						p.getWorld().dropItemNaturally(blk.getLocation(), new ItemStack(Material.DIAMOND));
					}
			}
			//Bukkit.broadcastMessage("Msg0");
			if (i.getItemMeta() == null){return;}
			//Bukkit.broadcastMessage("Msg1");
			if (!i.getItemMeta().hasLore()){return;}
			//Bukkit.broadcastMessage("Msg2");
			if(i.getType().name().contains("AXE") && (!i.getType().name().contains("PICKAXE"))){
				CutTree(blk, p, true);
			}
			if(i.getType().name().contains("PICKAXE") || i.getType().name().contains("SPADE")){
//				if (blk.getType() != Material.STONE){
//					return;
//				}
				if (isOre(blk.getType())){
					HarvestVein(blk, p);
					for (Entity e : p.getNearbyEntities(15, 15, 15)){
						if (e instanceof Item){
							Item it = (Item)e;
							//if(isOre(it.getItemStack().getType())){
								Vector vec = Utils.CrearVector(it.getLocation(), p.getEyeLocation());
								vec.multiply(0.1);
								it.setVelocity(vec);
							//}
						}
					}
					return;
				}
				Boolean dins = true; //true=dins, false=fora
				Boolean amunt = false;
				
				if (blk.getY() < p.getLocation().getBlockY()){
					dins = false;
					amunt = false;
				}
				if (blk.getY() > (p.getLocation().getBlockY() + 2)){
					dins = false;
					amunt = true;
				}
//				if (dins){
//					Bukkit.broadcastMessage("dins");
//				}else{
//					Bukkit.broadcastMessage("fora");
//				}
				ArrayList<BlockFace> faces = new ArrayList<BlockFace>();
				if (!dins){
					//Sota terra
					faces.add(BlockFace.NORTH);	      	      	
					faces.add(BlockFace.SOUTH);
					faces.add(BlockFace.EAST);	      	      	
					faces.add(BlockFace.WEST);
					faces.add(BlockFace.NORTH_EAST);	      	      	
					faces.add(BlockFace.NORTH_WEST);
					faces.add(BlockFace.SOUTH_EAST);	      	      	
					faces.add(BlockFace.SOUTH_WEST);
					
				}else{
					//Sobre terra
					faces.add(BlockFace.UP);	      	      	
					faces.add(BlockFace.DOWN);
				}
				
				
				for (BlockFace f : faces){
					Block b = blk.getRelative(f);
					if (dins == false){
						
						//sota
						Block relative = b.getRelative(BlockFace.UP);
						if (!amunt){
							relative = b.getRelative(BlockFace.UP);
						}else{
							relative = b.getRelative(BlockFace.DOWN);
						}
						if (relative.isLiquid()){
							continue;
						}
						if (!(relative.getPistonMoveReaction() == PistonMoveReaction.BREAK || relative.isEmpty())){
							continue;
						}
						if(p.getLocation().getY() > 40){
							
						}
						
					}else{
						
						//sobre
						if (b.getY() < p.getLocation().getBlockY()){
							continue;
						}
						if (b.getY() > (p.getLocation().getBlockY() + 2)){
							continue;
						}
						
					}
					
					if (!(b.getType() == Material.STONE 
							|| b.getType() == Material.GRASS 
							|| b.getType() == Material.DIRT 
							|| b.getType() == Material.SOUL_SAND 
							|| b.getType() == Material.SAND 
							|| b.getType() == Material.NETHERRACK 
							|| b.getType() == Material.SANDSTONE)){
						
						continue;
					}
					if (p.getFoodLevel() < 6){
						continue;
					}
					//Bukkit.broadcastMessage("done");
					b.breakNaturally(i);
					p.setExhaustion((float) (p.getExhaustion() + 0.065));
//					if (Utils.Possibilitat(50)){
//						i.setDurability((short) (i.getDurability() + 1));
//					}
					
				}  
			}
//			if(i.getType().name().contains("SPADE")){
//				if (!(blk.getType() == Material.STONE || blk.getType() == Material.DIRT)){
//					return;
//				}
//				ArrayList<BlockFace> faces = new ArrayList<BlockFace>();
//				faces.add(BlockFace.UP);	      	      	
//				faces.add(BlockFace.DOWN);
//				for (BlockFace f : faces){
//					Block b = blk.getRelative(f);
//					if (b.getY() < p.getLocation().getBlockY()){
//						continue;
//					}
//					if (b.getY() > (p.getLocation().getBlockY() + 2)){
//						continue;
//					}
//					if (b.getType() != Material.STONE){
//						continue;
//					}
//					if (p.getFoodLevel() < 6){
//						continue;
//					}
//
//					b.breakNaturally(i);
//					p.setExhaustion((float) (p.getExhaustion() + 0.075));
//					i.setDurability((short) (i.getDurability() + 1));
//				}  
//			}
			
			
			

      	
	  }
	}
	public boolean isOre(Material b) {
		return b == Material.COAL_ORE 
				|| b == Material.IRON_ORE 
				|| b == Material.GOLD_ORE 
				|| b == Material.GLOWSTONE 
				|| b == Material.REDSTONE_ORE 
				|| b == Material.GLOWING_REDSTONE_ORE 
				|| b == Material.DIAMOND_ORE 
				|| b == Material.LAPIS_ORE 
				|| b == Material.QUARTZ_ORE
				|| b == Material.EMERALD_ORE;
	}
	public void HarvestVein(Block b, Player p){
		CutTree(b, p, false);
	}
	public void CutTree(Block b, Player p, Boolean tree){
		ItemStack i = p.getItemInHand();
		Material m = b.getType();
		if (!(m == Material.LOG || m == Material.LOG_2 || m == Material.AIR) && tree) {
			return;
		}
		if (!isOre(m) && !tree) {
			return;
		}
		b.breakNaturally(i);
		p.setExhaustion((float) (p.getExhaustion() + 0.075));
		i.setDurability((short) (i.getDurability() + 1));
		// Recursivity
		BlockFace[] faces;
		faces = BlockFace.values();
		for (BlockFace f : faces) {
			Block nb = b.getRelative(f);
			if (nb.getType() == Material.AIR){
				continue;
			}
			CutTree(nb, p, tree);
			//FastSurvival.getWorld().createExplosion(nb.getLocation(), 2F);
			
		}
	
	}
	@EventHandler
    public void onInteract(PlayerInteractEvent evt) {
		
		Player p = evt.getPlayer();
		ItemStack i = p.getItemInHand();
    	World world = FastSurvival.getPlugin().getServer().getWorlds().get(0);
    	Inventory inv = p.getInventory();
//    	if (evt.getAction() == Action.RIGHT_CLICK_BLOCK && p.getItemInHand().getType() == Material.FEATHER){
//    		Block blk = evt.getClickedBlock().getRelative(evt.getBlockFace());
//    		
//    		Location l = blk.getLocation();
//    		if(Turret.canBeBuiltAt(l.clone())){
//    			Turret t = Turret.createTurret(l, p, false, false);
//        		t.Build();t.Attack();
//    		}
//    		
//    	}
//		if (evt.getAction() == Action.RIGHT_CLICK_BLOCK){
//			
//			Block blk = evt.getClickedBlock();
//			blk.breakNaturally();
//			//if(i.getType().name().contains("HOE")){
//				if (blk.getType() == Material.WHEAT || blk.getType() == Material.POTATO){
//					Bukkit.broadcastMessage("Wh Pot");
//				}
//				if (blk.getType() == Material.DIRT || blk.getType() == Material.GRASS){
//					int radius = 6;
//					int minX = blk.getX() - radius;
//					int maxX = blk.getX() + radius;
//					int minZ = blk.getZ() - radius;
//					int maxZ = blk.getZ() + radius;
//					 for (int x = minX; x <= maxX; x++) {
//				            for (int z = minZ; z <= maxZ; z++) {
//				            	Location l = new Location(FastSurvival.getWorld(), x, blk.getY(), z);
//				            	Block b = FastSurvival.getWorld().getBlockAt(l);
//								if (blk.getType() == Material.DIRT || blk.getType() == Material.GRASS){
//									blk.setType(Material.SOIL);
//								}
//				            }
//				        }
//				}
//			//}
//		}
    	
	}
	
	
}
